<?php
$GLOBALS["__65da1b1ec2d6653e8a0ab7848e53621" . "5"] = (@$GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"] ?: array()) + array("_a8391504b805b5d" . "572e9b1a5c5d0169" . "e" => base64_decode("Tm8gbGlzdCBpZA=" . "="), "_1d5727e95902d6ca0" . "a94581ac86acf26" => base64_decode("QXR0ZW1wdCB0byBsb2" . "FkIGF0dGVuZGVlcyBs" . "aXN0IHdpdGggbm8gbG" . "lzdF9pZA=="), "_31767d7ad5" . "8e706dbf47b" . "7a51a0fe6c4" => base64_decode("Y291bn" . "Q="), "_cce0d019091a" . "193c2ea098ab9" . "02d8821" => base64_decode("QXR0ZW1wdCB0byBzYXZlIGF0dGV" . "uZGVlcyB3aXRoIG5vIGxpc3RfaW" . "Qh"), "_c336a736f98472e69eb00" . "017dda5a17e" => base64_decode("dHJpZ2dlc" . "l9lcnJvcg" . "=="), "_c06c961f393742ecf" . "d52b72263ac9470" => base64_decode("aW5" . "0dm" . "Fs"), "_4d2b763f00ba1e8001879ba79a84" . "9269" => base64_decode("YXJyYXlfaW50ZXJzZWN0" . "X2tleQ=="), "_39b6f979f" . "725d2d0669" . "51011e1554" . "c14" => base64_decode("YXJyYXlfZGlmZ" . "l9rZXk="), "_f5e940c614f55e7" . "0f210df8306ffbd1" . "7" => base64_decode("YXJyYXlfZm" . "lsbF9rZXlz"));
abstract class CalendarEventParticipants extends ErrorHandler
{
    protected $is_list_loaded;
    protected $list_id = false;
    protected $users = array();
    protected $deleted_users = array();
    protected $new_users = array();
    protected $old_users = array();
    
    
    
    
    protected $event;
    public function __construct(CalendarObject $event)
    {
        $this->event = $event;
        $this->is_list_loaded = false;
    }
    
    
    
    
    
    
    public function SetUsers($_c9cc2169cfc80b4728d6b39dfdcba6bb)
    {
        
        
        $_c9cc2169cfc80b4728d6b39dfdcba6bb = $GLOBALS["__65da1b1ec2d6653" . "e8a0ab7848e536215"]["_f5e940c614f55e" . "70f210df8306ffb" . "d17"]($_c9cc2169cfc80b4728d6b39dfdcba6bb, 1);
        
        
        $this->deleted_users = $GLOBALS["__65da1b1ec2d6653e8a0ab7848e5362" . "15"]["_39b6f97" . "9f725d2d" . "06695101" . "1e1554c1" . "4"]($this->users, $_c9cc2169cfc80b4728d6b39dfdcba6bb);
        $this->new_users = $GLOBALS["__65da1b1ec2" . "d6653e8a0ab7" . "848e536215"]["_39b6f979f725d2d0" . "66951011e1554c14"]($_c9cc2169cfc80b4728d6b39dfdcba6bb, $this->users);
        $this->old_users = $GLOBALS["__65da1b1ec" . "2d6653e8a0a" . "b7848e53621" . "5"]["_4d2b763f" . "00ba1e800" . "1879ba79a" . "849269"]($this->users, $_c9cc2169cfc80b4728d6b39dfdcba6bb);
        $this->is_list_loaded = true;
    }
    public function Load()
    {
        if (!$this->list_id) {
            throw new Exception($GLOBALS["__65da1b1e" . "c2d6653e8a" . "0ab7848e53" . "6215"]["_1d5727e95902d6ca0a94581ac86a" . "cf26"]);
        }
        $this->deleted_users = array();
        $this->new_users = array();
        $this->old_users = array();
        $this->is_list_loaded = true;
    }
    public function SetListId($_0ea4e32b57963ac0cb3057e03e9aef64)
    {
        $this->list_id = $GLOBALS["__65da1b1ec2d6653e8a0ab78" . "48e536215"]["_c06c961f39" . "3742ecfd52b" . "72263ac9470"]($_0ea4e32b57963ac0cb3057e03e9aef64);
        if ($_0ea4e32b57963ac0cb3057e03e9aef64 === null) {
            $this->is_list_loaded = true;
        }
    }
    
    
    
    
    
    
    public function isAttendeesChanged()
    {
        return $GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"]["_31767d7ad" . "58e706dbf4" . "7b7a51a0fe" . "6c4"]($this->new_users) > 0 || $GLOBALS["__65da1b1ec2d6653e8a0ab7" . "848e536215"]["_31767d7" . "ad58e706" . "dbf47b7a" . "51a0fe6c" . "4"]($this->deleted_users) > 0;
    }
    public function Save()
    {
        if (!$this->list_id) {
            $GLOBALS["__65da1b1ec2d6653" . "e8a0ab7848e536215"]["_c336a736f" . "98472e69eb" . "00017dda5a" . "17e"]($GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"]["_a8391504b805b" . "5d572e9b1a5c5d" . "0169e"]);
            throw new Exception($GLOBALS["__65da1b1ec2d6653e" . "8a0ab7848e536215"]["_cce0d019091a193c2ea098ab902d882" . "1"]);
        }
        $this->SaveNewUsers();
        $this->DeleteUnattendedUsers();
        foreach ($this->new_users as $user_id => $_c96f552040dea8086bf8bdd70059542f) {
            $this->users[$user_id] = $_c96f552040dea8086bf8bdd70059542f;
        }
        
        
        $this->users = $GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"]["_39b6f979f725d2d066951011" . "e1554c14"]($this->users, $this->deleted_users);
        
        
    }
    public function GetNewUsers()
    {
        if (!$this->is_list_loaded) {
            $this->Load();
        }
        return $this->new_users;
    }
    public function GetAllUsers()
    {
        if (!$this->is_list_loaded) {
            $this->Load();
        }
        return (array) $this->users;
    }
    public function GetOldUsers()
    {
        if (!$this->is_list_loaded) {
            $this->Load();
        }
        return (array) $this->old_users;
    }
    public function GetDeletedUsers()
    {
        if (!$this->is_list_loaded) {
            $this->Load();
        }
        return (array) $this->deleted_users;
    }
    protected abstract function SaveNewUsers();
    protected abstract function DeleteUnattendedUsers();
}